{***************************************************}
{* 8-to-3 encoder unit for LogicGates6 application *}
{***************************************************}

unit encoder_8to3;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Menus, common;

type
  {*********}
  { TfEnc83 }
  {*********}
  TfEnc83 = class(TForm)
    mMenu: TMainMenu;
    mSettings, mSettingsSwitchesOff, mSettingsNoWarnings: TMenuItem;
    stTitle: TStaticText;
    imGate1, imGate2, imGate3: TImage;
    imSwitch0, imSwitch1, imSwitch3, imSwitch5, imSwitch7, imSwitch6, imSwitch4, imSwitch2: TImage;
    shSwitch0a, shSwitch0b, shSwitch1a, shSwitch1b, shSwitch3a, shSwitch3b, shSwitch5a, shSwitch5b: TShape;
    shSwitch7a, shSwitch7b, shSwitch6a, shSwitch6b, shSwitch4a, shSwitch4b, shSwitch2a, shSwitch2b: TShape;
    shLedA0, shLedA1, shLedA2: TShape;
    shLedY0, shLedY1, shLedY3, shLedY5, shLedY7, shLedY6, shLedY4, shLedY2: TShape;
    stDetails, stBoolean: TStaticText;
    stA0, stA1, stA2: TStaticText;
    stY0, stY1, stY3, stY5, stY7, stY6, stY4, stY2: TStaticText;
    laIn, laOut, laA0, laA1, laA2: TLabel;
    laY0, laY4, laY5, laY6, laY7, laY3, laY2, laY1: TLabel;
    Label1, Label10, Label11, Label12, Label13, Label14, Label16, Label17, Label18, Label19: TLabel;
    Label2, Label20, Label22, Label23, Label24, Label25, Label26, Label29: TLabel;
    Label3, Label30, Label31, Label32, Label33, Label34, Label35, Label36, Label37, Label38, Label39: TLabel;
    Label4, Label40, Label41, Label42, Label43, Label44, Label45, Label46, Label47, Label48, Label49: TLabel;
    Label5, Label50, Label51, Label52, Label53, Label54, Label55, Label56, Label57, Label58, Label59: TLabel;
    Label6, Label60, Label61, Label62, Label63, Label64, Label65, Label66, Label67, Label68, Label69: TLabel;
    Label7, Label70, Label71, Label72, Label73, Label74, Label75, Label76, Label77, Label78, Label79: TLabel;
    Label8, Label80, Label81, Label82, Label83, Label84, Label85, Label86, Label87, Label88, Label89: TLabel;
    Label9, Label90, Label91, Label92, Label93, Label94, Label95, Label96, Label97, Label98: TLabel;
    Shape1, Shape10, Shape11, Shape12, Shape13, Shape14, Shape15, Shape16, Shape21, Shape22, Shape23: TShape;
    Shape24, Shape25, Shape26, Shape27, Shape28, Shape29, Shape3, Shape30, Shape31, Shape32, Shape33: TShape;
    Shape34, Shape35, Shape36, Shape37, Shape38, Shape39, Shape40, Shape41, Shape42, Shape43, Shape44: TShape;
    Shape45, Shape46, Shape47, Shape48, Shape49, Shape50, Shape51, Shape52, Shape53, Shape54, Shape55: TShape;
    Shape56, Shape57, Shape58, Shape59, Shape6, Shape60, Shape61, Shape62, Shape63, Shape64, Shape65: TShape;
    Shape66, Shape67, Shape68, Shape69, Shape7, Shape70, Shape71, Shape72, Shape73, Shape74, Shape75: TShape;
    Shape76, Shape77, Shape78, Shape79, Shape8, Shape80, Shape81, Shape82, Shape83, Shape84, Shape85: TShape;
    Shape86, Shape87, Shape88, Shape89, Shape90, Shape91, Shape92: TShape;
    Memo1: TMemo;
    btClose: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mSettingsSwitchesOffClick(Sender: TObject);
    procedure mSettingsNoWarningsClick(Sender: TObject);
    procedure imSwitch0Click(Sender: TObject);
    procedure imSwitch1Click(Sender: TObject);
    procedure imSwitch2Click(Sender: TObject);
    procedure imSwitch3Click(Sender: TObject);
    procedure imSwitch4Click(Sender: TObject);
    procedure imSwitch5Click(Sender: TObject);
    procedure imSwitch6Click(Sender: TObject);
    procedure imSwitch7Click(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
  private
    aInput: array[0..7] of Boolean;                                            // input lines status (variables)
    aOutput: array[0..2] of Boolean;                                           // output lines status (variables)
    aSwitches: array[0..7] of TSwitch;                                         // input lines switches
    aLedsInput: array[0..7] of TLed;                                           // input lines LEds
    aLedsOutput: array[0..2] of TLed;                                          // output lines LEDs
    bSwitchesOff, bNoWarnings: Boolean;
  end;

var
  fEnc83: TfEnc83;

implementation

{$R *.lfm}

{*********}
{ TfEnc83 }
{*********}

{ Application start: Init the LED and Switch records }

procedure TfEnc83.FormCreate(Sender: TObject);

var
  I: Integer;

begin
  // Apply subscripts
  stY7.Caption := StringReplace(stY7.Caption, '7', SUB_Numbers[7], []); stY6.Caption := StringReplace(stY6.Caption, '6', SUB_Numbers[6], []);
  stY5.Caption := StringReplace(stY5.Caption, '5', SUB_Numbers[5], []); stY4.Caption := StringReplace(stY4.Caption, '4', SUB_Numbers[4], []);
  stY3.Caption := StringReplace(stY3.Caption, '3', SUB_Numbers[3], []); stY2.Caption := StringReplace(stY2.Caption, '2', SUB_Numbers[2], []);
  stY1.Caption := StringReplace(stY1.Caption, '1', SUB_Numbers[1], []); stY0.Caption := StringReplace(stY0.Caption, '0', SUB_Numbers[0], []);
  stA2.Caption := StringReplace(stA2.Caption, '2', SUB_Numbers[2], []);
  stA1.Caption := StringReplace(stA1.Caption, '1', SUB_Numbers[1], []);
  stA0.Caption := StringReplace(stA0.Caption, '0', SUB_Numbers[0], []);
  laY7.Caption := StringReplace(laY7.Caption, '7', SUB_Numbers[7], []); laY6.Caption := StringReplace(laY6.Caption, '6', SUB_Numbers[6], []);
  laY5.Caption := StringReplace(laY5.Caption, '5', SUB_Numbers[5], []); laY4.Caption := StringReplace(laY4.Caption, '4', SUB_Numbers[4], []);
  laY3.Caption := StringReplace(laY3.Caption, '3', SUB_Numbers[3], []); laY2.Caption := StringReplace(laY2.Caption, '2', SUB_Numbers[2], []);
  laY1.Caption := StringReplace(laY1.Caption, '1', SUB_Numbers[1], []); laY0.Caption := StringReplace(laY0.Caption, '0', SUB_Numbers[0], []);
  laA2.Caption := StringReplace(laA2.Caption, '2', SUB_Numbers[2], []);
  laA1.Caption := StringReplace(laA1.Caption, '1', SUB_Numbers[1], []);
  laA0.Caption := StringReplace(laA0.Caption, '0', SUB_Numbers[0], []);
  for I := 0 to 7 do begin
    stDetails.Caption := StringReplace(stDetails.Caption, 'Y' + IntToStr(I), 'Y' + SUB_Numbers[I], [rfReplaceAll]);
    stBoolean.Caption := StringReplace(stBoolean.Caption, IntToStr(I), SUB_Numbers[I], [rfReplaceAll]);
  end;
  // Create arrays with switches and LEds
  aLedsInput[0].LedShape := shLedY0; aLedsInput[1].LedShape := shLedY1;
  aLedsInput[2].LedShape := shLedY2; aLedsInput[3].LedShape := shLedY3;
  aLedsInput[4].LedShape := shLedY4; aLedsInput[5].LedShape := shLedY5;
  aLedsInput[6].LedShape := shLedY6; aLedsInput[7].LedShape := shLedY7;
  aLedsOutput[0].LedShape := shLedA0; aLedsOutput[1].LedShape := shLedA1; aLedsOutput[2].LedShape := shLedA2;
  with aSwitches[0] do begin
    SwitchShapeA := shSwitch0a; SwitchShapeB := shSwitch0b;
    SwitchShapeAOffPos := 560;                                                 // vertical position (Top property) of open switch
  end;
  with aSwitches[1] do begin
    SwitchShapeA := shSwitch1a; SwitchShapeB := shSwitch1b;
    SwitchShapeAOffPos := 492;
  end;
  with aSwitches[2] do begin
    SwitchShapeA := shSwitch2a; SwitchShapeB := shSwitch2b;
    SwitchShapeAOffPos := 428;
  end;
  with aSwitches[3] do begin
    SwitchShapeA := shSwitch3a; SwitchShapeB := shSwitch3b;
    SwitchShapeAOffPos := 359;
  end;
  with aSwitches[4] do begin
    SwitchShapeA := shSwitch4a; SwitchShapeB := shSwitch4b;
    SwitchShapeAOffPos := 293;
  end;
  with aSwitches[5] do begin
    SwitchShapeA := shSwitch5a; SwitchShapeB := shSwitch5b;
    SwitchShapeAOffPos := 227;
  end;
  with aSwitches[6] do begin
    SwitchShapeA := shSwitch6a; SwitchShapeB := shSwitch6b;
    SwitchShapeAOffPos := 161;
  end;
  with aSwitches[7] do begin
    SwitchShapeA := shSwitch7a; SwitchShapeB := shSwitch7b;
    SwitchShapeAOffPos := 96;
  end;
  // Default setings for switch auto-close and warning messages
  bSwitchesOff := False; bNoWarnings := False;
end;

{ Window show-up: Init the encoder circuit }

procedure TfEnc83.FormActivate(Sender: TObject);

var
  I: Integer;

begin
  // Input line 0 active High
  SwitchOn(aSwitches[0]); LedOn(aLedsInput[0]); aInput[0] := True;
  // All other input lines Low
  for I := 1 to 7 do begin
    SwitchOff(aSwitches[I]);
    LedOff(aLedsInput[I]);
    aInput[I] := False;
  end;
  // All output lines Low
  for I := 0 to 2 do begin
    LedOff(aLedsOutput[I]);
    aOutput[I] := False;
  end;
end;

{ Menu item "Settings > Automatically push switches off": Toggle auto switches-off }

procedure TfEnc83.mSettingsSwitchesOffClick(Sender: TObject);

begin
  if mSettingsSwitchesOff.Checked then
    mSettingsSwitchesOff.Checked := False
  else
    mSettingsSwitchesOff.Checked := True;
  bSwitchesOff := mSettingsSwitchesOff.Checked;
end;

{ Menu item "Settings > Do not display warning messages": Toggle warnings display }

procedure TfEnc83.mSettingsNoWarningsClick(Sender: TObject);

begin
  if mSettingsNoWarnings.Checked then
    mSettingsNoWarnings.Checked := False
  else
    mSettingsNoWarnings.Checked := True;
  bNoWarnings := mSettingsNoWarnings.Checked;
end;

{ User click on switches: Set corr. input line High or Low; do 8-to-3 encoder simulation }

procedure TfEnc83.imSwitch0Click(Sender: TObject);

begin
  SwitchOnOff(0, True, not aSwitches[0].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch1Click(Sender: TObject);

begin
  SwitchOnOff(1, True, not aSwitches[1].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch2Click(Sender: TObject);

begin
  SwitchOnOff(2, True, not aSwitches[2].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch3Click(Sender: TObject);

begin
  SwitchOnOff(3, True, not aSwitches[3].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch4Click(Sender: TObject);

begin
  SwitchOnOff(4, True, not aSwitches[4].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch5Click(Sender: TObject);

begin
  SwitchOnOff(5, True, not aSwitches[5].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch6Click(Sender: TObject);

begin
  SwitchOnOff(6, True, not aSwitches[6].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

procedure TfEnc83.imSwitch7Click(Sender: TObject);

begin
  SwitchOnOff(7, True, not aSwitches[7].SwitchOn, aSwitches, aLedsInput, aInput, bSwitchesOff, bNoWarnings);
  Encoder83(aInput, aOutput, aLedsOutput);
end;

{Button "Close": Close the simulation window }

procedure TfEnc83.btCloseClick(Sender: TObject);

begin
  Close;
end;

end.

